//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 24-1
//
// Uses inline assembly to count the number of 1 bits in a byte.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>

#byte status = 0xFD8
#bit    c = status.0

int8 number_of_one_bits(int8 value) {
   int8 count = 0;
   int8 i = 8;

   #asm
   LOOP1:
      bcf C
      rlcf value, F
      btfsc C      
      incf count
      decfsz i
      goto Loop1
   #endasm
   
   return count;
}

void main(void) 
{
   for(;;) 
   {
      printf("\r\nEnter Number: ");
      printf("\r\nThere are %u 1's in that number!", number_of_one_bits(get_int_usb()));
   }
}
